/**
 * 
 */
package net.bigeon.gclc.process;

import static org.junit.Assert.assertNotNull;

import org.junit.Test;

import net.bigeon.gclc.command.SubedCommand;
import net.bigeon.gclc.exception.InvalidCommandName;

/**
 * @author Emmanuel Bigeon
 *
 */
public class ProcessAttachementTest {

    /** Test method for
     * {@link net.bigeon.gclc.process.ProcessAttachement#attach(net.bigeon.gclc.command.ICommandProvider)}.
     * 
     * @throws InvalidCommandName if the command has already some subcommand that is
     *         incompatible */
    @Test
    public void testAttach() throws InvalidCommandName {
        final TaskPool pool = new TaskPool();
        final ProcessAttachement attachement = new ProcessAttachement(pool);
        final SubedCommand testPoint = new SubedCommand("test");
        attachement.attach(testPoint);
        assertNotNull("Commands should be added", testPoint.get("kill"));
        assertNotNull("Commands should be added", testPoint.get("list"));
    }

}
