/**
 * 
 */
package net.bigeon.gclc.swt;

import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.verify;

import java.io.BufferedReader;

import org.eclipse.swt.widgets.Label;
import org.junit.Test;

/**
 * @author Emmanuel Bigeon
 *
 */
public class ConsolePromptManagerTest {

    private final Label label = mock(Label.class);

    private final ConsolePromptManager manager = new ConsolePromptManager(label);

    /**
     * Test method for {@link net.bigeon.gclc.swt.ConsolePromptManager#setPrompt(java.lang.String)}.
     */
    @Test
    public void testSetPrompt() {
        manager.setPrompt("abc");
        verify(label).setText("abc");
    }

    /**
     * Test method for {@link net.bigeon.gclc.swt.ConsolePromptManager#setStream(java.io.BufferedReader)}.
     */
    @Test
    public void testSetStream() {
        BufferedReader output = mock(BufferedReader.class);
        manager.setStream(output);
        manager.setStream(output);
        output = mock(BufferedReader.class);
        manager.setStream(output);
        manager.setStream(null);
        manager.setStream(output);
    }

}
