package net.bigeon.gclc.utils;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;

import java.io.IOException;

import org.junit.Test;

import net.bigeon.gclc.manager.ConsoleInput;
import net.bigeon.gclc.tools.ConstantString;

public class EmptyInputTest {

    @Test
    public void testClose() throws IOException {
        final ConsoleInput input = EmptyInput.INSTANCE;
        // several close operation shold create no error
        input.close();
        input.close();
        assertFalse("This source input should never be closed", input.isClosed());
    }

    @Test
    public void testGetPrompt() {
        
        final ConsoleInput input = EmptyInput.INSTANCE;
        final String init = input.getPrompt().get();
        input.setPrompt("some prompt different from "+init);
        assertEquals("Prompts should not be changed", init, input.getPrompt().get());
        
        input.setPrompt(new ConstantString("some other prompt different from "+init));
        assertEquals("Prompts should not be changed", init, input.getPrompt().get());
    }

    @Test
    public void testInterruptPrompt() {
        // Nothing to test, really...
        final ConsoleInput input = EmptyInput.INSTANCE;
        // several close operation shold create no error
        input.interruptPrompt();
        assertFalse("This source input should never be closed", input.isClosed());
    }

    @Test
    public void testIsClosed() throws IOException {
        final ConsoleInput input = EmptyInput.INSTANCE;
        // several close operation shold create no error
        assertFalse("This source input should never be closed", input.isClosed());
        input.close();
        assertFalse("This source input should never be closed", input.isClosed());
        input.close();
        assertFalse("This source input should never be closed", input.isClosed());
    }

    @Test
    public void testPrompt() throws IOException {
        final ConsoleInput input = EmptyInput.INSTANCE;
        // several close operation shold create no error
        assertEquals("Any prompt should return the empty value", "", input.prompt());
        assertEquals("Any prompt should return the empty value", "", input.prompt(0));
        assertEquals("Any prompt should return the empty value", "", input.prompt(12));
        assertEquals("Any prompt should return the empty value", "", input.prompt("Test"));
        assertEquals("Any prompt should return the empty value", "", input.prompt("Test", 0));
        assertEquals("Any prompt should return the empty value", "", input.prompt("Test", 12));
    }
}
